# $Id$

package raidstatus::mod_ataraid;

use warnings;
use strict;

our $name = "mod_ataraid";
our @platforms = "FreeBSD";

# use this binary to query information
our $atacontrol = "/sbin/atacontrol";
# default unit numbers to check/query
our @units = ("ar0", "ar1", "ar2", "ar3");

# use CVS/RCS Revision tag to set up the package version
#our $VERSION = do { my @r = (q$Revision$ =~ /\d+/g); sprintf "%d."."%02d" x $#r, @r };
our $VERSION = "git";

sub new {
  my ($class) = @_;
  my $self = {};

  bless ($self,$class);
  return $self;
}

sub getName {
  my ($self) = @_;
  return $name;
}

sub getPlatforms {
  my ($self) = @_;
  return @platforms;
}

sub getUnits {
  my ($self) = @_;
  my @detectedUnits = ();
  foreach my $unit (@units){
    my $cmd = "$atacontrol status $unit 2>&1";
    my $ret = `$cmd`;
    chomp $ret; 
    if ( $ret !~ m/Device\snot\sconfigured/ ){
        push(@detectedUnits,$unit);
    }
  }
  return @detectedUnits;
}

sub checkUnits {
  my ($self, @units) = @_;
  my @unitStatus = ();
  foreach my $unit (@units){
    my $cmd= "$atacontrol status $unit 2>&1";
    my $ret = `$cmd`;
    chomp $ret;
    if ( $ret =~ m/status:\sREADY/ ){
      push(@unitStatus, "$unit:OK");
    } elsif ( $ret =~ m/status:\sDEGRADED/ ) {
      push(@unitStatus, "$unit:CRITICAL");
    } elsif ( $ret =~ m/status:\sREBUILDING/ ) {
      push(@unitStatus, "$unit:WARNING");
    } else {
      push(@unitStatus, "$unit:UNEXPECTED");
    }
  }
  return @unitStatus;
}

1;

# vim: ai et ts=2 shiftwidth=2

